sub get_recipe   {
  my ($class, $r, $recipe) = @_ ;

  my $self ;
  my $param  = $r->component->param  ;
  my $config = $r->component->config  ;
  my ($src)  = $param->inputfile =~ /^.*\.(.*?)$/ ;
  my ($dest) = $r->param->uri =~ /^.*\.(.*?)$/ ;

  if ($src eq 'pl') {
    $config->syntax('Perl') ;
    return Embperl::Recipe::Embperl->get_recipe ($r, $recipe) ;
  }

  if ($src eq 'pod' || $src eq 'pm')  {
    $config->escmode(0) ;
    if ($dest eq 'pod')  {
      $config->syntax('Text') ;
      return Embperl::Recipe::Embperl->get_recipe ($r, $recipe) ;
    }

    $config->syntax('POD') ;
    if ($dest eq 'xml')  {
      return Embperl::Recipe::Embperl->get_recipe ($r, $recipe) ;
    }

    $config->xsltstylesheet('pod.xsl') ;
    $r->param->uri =~ /^.*\/(.*)(\..*?)$/ ;
    $param->xsltparam({page => $r->thread->form_hash->{page} || 0, 
                     basename => "'$1'", extension => "'$2'"}) ;
    return Embperl::Recipe::EmbperlXSLT->get_recipe ($r, $recipe) ;
  }
  
  
  if ($src eq 'epl' || $src eq 'htm') {
    $config->syntax('Embperl') ;
    return Embperl::Recipe::Embperl->get_recipe ($r, $recipe) ;
  }

  $config->syntax('Text') ;
  return Embperl::Recipe::Embperl->get_recipe ($r, $recipe) ;
}
